<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use RxConnexionBundle\Entity\PatientLetterEntity;
use RxConnexionBundle\Form\Type\LetterTemplateEmailForm;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Form\FormEvent;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;


class LetterTemplateForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('id', HiddenType::class)
            ->add('letterType', ChoiceType::class, array(
                'label' => 'Letter Type',
                'label_attr' => array(
                    'class' => 'required'
                ),
                'required' => false,
                'choices' => PatientLetterEntity::LETTERS
            ))
            ->add('faxCoverBody', TextareaType::class, array(
                'label' => 'Fax Cover Body',
                'required' => false
            ))
            ->add('body', TextareaType::class, array(
                'label' => 'Custom Body',
                'required' => false
            ))
            ->add('emailBody', TextareaType::class, array(
                'label' => 'Email Body',
                'required' => false
            ))
            ->add('letterTemplateEmails', CollectionType::class, array(
                'entry_type' => LetterTemplateEmailForm::class,
                'allow_add' => true,
                'allow_delete' => true,
                'prototype' => false,
                'by_reference' => false
            ))
            ->add('company', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {

                $form = $event->getForm();
                $data = $event->getData();
                $company = $data->getCompany();

                $form
                    ->add('company_description', TextType::class, array(
                        'mapped' => false,
                        'label' => 'Company',
                        'label_attr' => array(
                            'class' => 'middle'
                        ),
                        'required' => false,
                        'data' => $company ? $company->getDescription() : ''
                    ));
            });

        $builder->get('company')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:CompanyEntity', false));
    }

    public function getBlockPrefix()
    {
        return 'letterTemplate';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\LetterTemplateEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'letterTemplateEntity_intention',
            'action'          => 'n'
        ));
    }
}